{
                    DOT-BO-GI assistant: PUBLIC
                    Being invoked by D.PAS only

                    (c) aromanix
}

type
  FCB = record
            FF        : byte;                {must be 0FFh}
            RESERVED1 : array[1..5] of byte; {must be 0s}
            ATTR      : byte;
            DRIVEID   : byte;
            FILENAME  : array[1..11] of char;
            CURBLOCK  : word;
            RECSIZE   : word;
            FILESIZE  : longint;
            DATE      : word;
            TIME      : word;
            RESERVED2 : array[1..8] of byte;
            CURREC    : byte;
            RELATIVE  : longint
          end;

  DTA=record
    sk1:array[1..8] of char;
    ol:array[1..11] of char;
    sk2:array[1..5] of char;
    nl:array[1..11] of char;
    sk3:array[1..29] of char;
  end;

  ScrnCell=array[1..25,1..80] of word;

const
  ERR152='Drive NOT ready.';
  ERR158='Sector NOT found.';
  ERR161='Device read FAULT.';
  ERR162='Hardware FAILURE.';

  Key_Seg  = $40;
  First    = $1a;
  Last     = $1c;
  BufBegin = $80;
  BufEnd   = $82;

var
  fcb_:fcb;
  dta_:dta;
  Scrn    :^ScrnCell;

function getvolume(id:byte):string;
var result:boolean;
begin
    fcb_.ff:=$ff;
    fillchar(fcb_.reserved1,5,0);
    fcb_.attr:=$08; { 08 means VolumdID }
    fcb_.driveid:=id;
    fillchar(fcb_.filename,11,'?');

    asm
      push      ds

      mov       ax,seg dta_
      mov       ds,ax
      mov       dx,offset dta_
      mov       ah,1ah
      int       21h

      mov       ax,seg fcb_
      mov       ds,ax
      mov       dx,offset fcb_
      mov       ah,11h
      int       21h
      inc       al
      mov       result,al

      pop       ds
    end;

  if result then getvolume:=dta_.ol else getvolume:='           ';
end;

FUNCTION GetKey:word; assembler;
asm
   mov    ax,Key_Seg
   mov    es,ax
   xor    ax,ax
   mov    si,es:[First]
   cmp    si,es:[Last]
   je     @end
   mov    ax,es:[si]
   add    si,02
   cmp    si,es:[BufEnd]
   jb     @Ok
   mov    si,es:[BufBegin]
   @Ok:
   mov    es:[First],si
   cmp    al,224
   jne    @end
   cmp    ah,70
   jb     @end
   xor    al,al
   @end:
end;

function eliminateblank(s:string;nf:boolean):string;
begin
  if nf then while s[1]=' ' do delete(s,1,1) { eliminate forehead blanks }
  else while s[length(s)]=' ' do delete(s,length(s),1); { eliminate backhead blinks }
  eliminateblank:=s;
end;

procedure gsound;   { global sound }
begin
  sounds(3000,50,100);
  sounds(3000,50,50);
end;

procedure ITC(s:string);     {Input To Consol}
var T:byte;
    c:char;
begin
  for T:=1 to length(s) do begin
      c:=s[t];
      asm
         mov        cl,     c
         mov        ah,     5h
         int        16h
      end;
  end;
end;

{ check ESC to stop without clearing key buffer }
procedure CheckESC;
begin
  if port[$60]=1 then halt;
end;

procedure Pause;
var g:byte;
begin
  fprint('Press any key...'+spc(' ',64),1,25,_CT[15]+16);

  repeat
        g:=hi(getkey); { get key scan code }
        if g=1 then begin
           fprint(spc(' ',80),1,25,_CT[7]);
           halt;
        end;
  until g<>0;

  fprint(spc(' ',80),1,25,_CT[7]);
end;

procedure pr(s:string;x,c:byte;nf:boolean);
begin
  fprint(s,x,l_scr,c);

  if nf then begin
     if l_scr<25 then inc(l_scr)
     else begin scrollup;
          { delete a last line at screen }
          asm
             mov     ax,1824
             mov     es,_DISPSEG
             mov     di,3840
             mov     cx,80
             cld
          @cont:
             mov     es:[di],ax
             add     di,2
             loop    @cont
          end;
     end;

     if opt.pause_ then
        if c_scr<23 then inc(c_scr)
        else begin
             c_scr:=0;
             pause;
        end;
  end;
end;

procedure asttyper(n:word;s:string);
var f:text;
    v:string;
begin
  opt.pause_:=true;

  pr(s+spc(' ',80-length(s)),1,_CT[15]+16,true);

  assign(F,S);
  {$I-}
  reset(F);
  {$I+}
  if ioresult<>0 then begin
     pr('Can''t read '+s,1,_CT[4],true);
     halt;
  end;

  while not eof(f) do begin
        readln(f,v);
        pr(v,1,_CT[7],true);
  end;

  close(f);
  halt;
end;

procedure Run(S:string);
var F:text;
    t:byte;
begin
  assign(F,dbg_assistant);
  rewrite(F);
  writeln(F,'@Echo Off');
  writeln(F,'REM Sub-processor for DBG');
  for t:=1 to length(s) do
      if s[t]='>' then writeln(f) else write(f,s[t]);

  if tab then begin
     writeln(f);
     writeln(f,paramstr(0)+' '+wholepara+r_sign,
               r_code.it,' ', r_code.y,' ', r_code.idx);
  end;

  close(F);
  itc(dbg_assistant+#13);
end;

procedure applityper(it:word);
var s:string;
begin
  s:='';
  if viewer<>'' then begin
     if viewer_dest[1]='!' then s:=path+list[it]^.name;
     if (viewer_dest[3]='!') and (length(viewer_dest)=3) then
        if list[it]^.ext<>'' then s:=s+'.'+list[it]^.ext;
     run(viewer+' '+s+' '+viewer_option);
     halt;
  end;
end;

procedure styper(it:word);
var s:string;
begin
  if list[it]^.item=255 then begin
     gsound;
     exit;
  end;

  applityper(it);

  s:=path+list[it]^.name;
  if list[it]^.ext<>'' then s:=s+'.'+list[it]^.ext;
  asttyper(it,s);
end;

function timecf(h,m:byte):string; { time changed format }
var AP:char;
begin
    if H>12 then begin
       dec(H,12);
       AP:='p'
    end else begin
        if H=0 then H:=12;
        AP:='a';
    end;

    timecf:=lz(H,false)+':'+lz(M,true)+ap;
end;

procedure PutTime(X,Y,C:byte);
var TH,TM,dummy:word;
begin
    gettime(TH,TM,dummy,dummy);
    FPrint(timecf(th,tm),X,Y,C)
end;

procedure askboxdraw(t,l,b,r,c:byte);
var x,y:byte;
begin
  for y:=t to b do
      for x:=l to r do scrn^[y,x]:=word(c) shl 8 + 32;
end;

procedure askbox(top,left,bottom,right,c:byte);
var SXY:array[1..4] of byte;
    WideX,WideY,Count:byte;
begin
  SXY[1]:= Top;
  SXY[2]:= Left;
  SXY[3]:= Bottom;
  SXY[4]:= Right;

  Count :=0;
  WideX :=(Right-Left) div 10;
  WideY :=(Bottom-Top) div 10;

  if WideX=0 then WideX:=(Right-Left) div 2;
  if WideY=0 then begin
    WideY:=(Bottom-Top) div 2;
    Count:=4
  end;

  Top  := (Bottom-Top) div 2+Top;
  Left := (Right-Left) div 2+Left;

  if Top  = 0  then Top  := 1;
  if Left = 0  then Left := 1;

  Bottom  := succ(Top);
  Right   := succ(Left);

  repeat
    delay(60);
    inc(Count);

    askboxdraw(top,left,bottom,right,c);

    if Top   > SXY[1] then dec(Top,WideY);
    if Left  > SXY[2] then dec(Left,WideX);
    if Bottom< SXY[3] then inc(Bottom,WideY);
    if Right < SXY[4] then inc(Right,WideX);

    if Top   < SXY[1] then Top   := SXY[1];
    if Left  < SXY[2] then Left  := SXY[2];
    if Bottom> SXY[3] then Bottom:= SXY[3];
    if Right > SXY[4] then Right := SXY[4]
  until Count=5;

  delay(50);
  askboxdraw(top,left,bottom,right,c);
  delay(50);
  askboxdraw(SXY[1],SXY[2],SXY[3],SXY[4],c);
end;

function ask(top,mc:byte;item,msg,m2:string):byte;
var
  t,i,max,right,m2c,left:byte;
  c:word;
  buf:pointer;
  ia:array[0..5] of string[15];

procedure drawbar(nf:boolean);
var c:byte;
begin
  if nf then c:=241 else c:=112;
  fprint(ia[t],left+2+(max+2)*t,top+2+m2c,c);
end;

procedure drawbarshadow;
var x:byte;
begin
  x:=left+2+(max+2)*t;
  fprint(spc(#220,max),x+1,top+3+m2c,mc);
  fprint(#220,x+max,top+2+m2c,16*mc);
end;

procedure pushenter;
var x:byte;
begin
  x:=left+2+(max+2)*t;
  fprint(ia[t],x+1,top+2+m2c,241);
  fprint(' ',x,top+2+m2c,mc*16);
  fprint(spc(' ',max),x+1,top+3+m2c,mc*16);
  delay(100);
end;

begin
  mem[0:$41A]:=mem[0:$41C]; { clear key buffer }

  i      :=0;
  ia[0]  :='';
  max    :=0;

  for t:=1 to length(item) do
    if item[t]=',' then begin
      if i<5 then begin
        inc(i);
        ia[i]:='';
      end;
    end else ia[i]:=ia[i]+item[t];

  for t:=0 to i do begin
    c:=length(ia[t])+4;
    if c>max then max:=c;
  end;

  for t:=0 to i do
    ia[t]:=spc(' ',(max-length(ia[t])) div 2)+ia[t]+
           spc(' ',(max-length(ia[t])) div 2);

  left:=(79-(max+2)*(i+1)) div 2;
  right:=left+(max+2)*(i+1)+1;
  if m2='' then m2c:=0 else m2c:=2;

  savescreen(top,left,top+3+m2c,right,buf);
  askbox(top,left,top+3+m2c,right,mc*16+15);

  if msg='' then msg:='DOT BO GI Request';
  fprint(spc(' ',right-left+1),left,top,240);
  if length(msg)>right-left+1 then msg[0]:=chr(right-left+1);
  fprint(msg,left+((right-left+1-length(msg)) div 2),top,240);

  if m2<>'' then begin
    if length(m2)>right-left+1 then m2[0]:=chr(right-left+1);
    fprint(m2,left+((right-left+1-length(m2)) div 2),top+2,mc*16+15);
  end;

  for t:=0 to i do begin
    if length(ia[t])<max then ia[t]:=ia[t]+spc(' ',max-length(ia[t]));
    drawbar(false);
    drawbarshadow;
  end;

  t:=0;
  drawbar(true);

  repeat
    if opt.func=shell_ then puttime(72,1,_CT[1]+112);

    c:=getkey;
    if c=0 then continue;

    drawbar(false);
    case c of
      $4B00,$4800:if t>0 then dec(t) else t:=i;
      $5000,$4D00:if t<i then inc(t) else t:=0;
      $1C0D,$E00D:begin
        pushenter;
        right:=t;
        i:=0;
      end;
    end;
    drawbar(true);

  until (c=$011B) or (i=0);
  if c=$011B then right:=$ff;

  ask:=right;
  restorescreen(left,top,buf,true);
end;

function SureDir(S:string):boolean;
var A:word;
    F:file;
begin
  assign(F,S);
  getfattr(F,A);
  if A and directory<>0 then SureDir:=true else SureDir:=false
end;

function datecf(year,month,day:word):string;
begin
  datecf:=num2str(year)+'-'+monthdef[month]+'-'+lz(day,true);
end;

function sizecf(v:longint):string; { size changed format }
var s,p:string;
begin
  if v div 1048576>0 then begin
     str((v div 1048576):4,s);
     str(((v mod 1048576) * 10 div 1048576),p);
     s:=s+'.'+p[1]+'m';
  end else if v div 1024>0 then begin
      str((v div 1024):6,s);
      s:=s+'k';
  end else begin
      str(v:6,s);
      s:=s+'b';
  end;
  sizecf:=s
end;

procedure whatkind(p:word);
var t,w:byte;
begin
  w:=0;

  for t:=1 to ext_max do
      if (ext_data[t][1]=list[p]^.ext[1]) and (ext_data[t]=list[p]^.ext) then begin
         w:=t;
         break
      end;

  list[p]^.item:=w;
end;

function whatcolor(n:byte):byte;
var c:byte;
begin
  case n of
    255                 :c:=_CT[9];         { directory }
    1..3                :c:=_ct[10];        { executive }
    5..7,24,25          :c:=_CT[4];         { backup & temporary }
    else                 c:=_CT[7];         { normal }
  end;

  whatcolor:=c;
end;

procedure extrainfo_counter(n:byte);
begin
  case n of
    1:     inc(extrainfo.exe_);
    2:     inc(extrainfo.com_);
    3:     inc(extrainfo.bat_);
    4:     inc(extrainfo.sys_);
    255:   inc(extrainfo.dir_);
    5..7:  inc(extrainfo.bak_);
    8..15: inc(extrainfo.arc_);
    16..18:inc(extrainfo.txt_);
  end;
end;

procedure detecterrors;
var d:searchrec;
    c:string;
begin
  c:=getpath(wholepara,1,true);
  if (c[length(c)]<>'\') and (SureDir(c)) then c:=c+'\*.*' else c:=c+'*.*';

  findfirst(c,anyfile,d);
  case doserror of
    152:pr(ERR152,1,_CT[14],true);
    158:pr(ERR158,1,_CT[14],true);
    161:pr(ERR161,1,_CT[14],true);
    162:pr(ERR162,1,_CT[14],true);
  end;

  if doserror in [152,158,161,162] then halt;
end;

procedure SepPath(S:string;var P:dirstr;var N:namestr;var E:extstr);
begin
  if (S[length(S)]<>'\') and (SureDir(S)) then S:=S+'\';
  detecterrors;
  fsplit(fexpand(s),P,N,E);
end;

function CompletePath(s:string):string;
begin
  SepPath(s,path,name,exten);
  if name='' then name:='*';   { name }
  if exten='' then exten:='.*';  { extension }
  CompletePath:=path+name+exten;
end;

procedure FileDel(S:string);
var F:file;
begin
  assign(F,S);
  setfattr(F,0);
  erase(F)
end;

function astdeleter(n:word;s:string):boolean;
var d:searchrec;
    ds:string;
begin
  astdeleter:=false;

  if list[n]^.item=255 then ds:='Dir: ' else ds:='';
  fsplit(s,Path,Name,Exten);

  if ask(10,_CT[4],'CANCEL,DELETE','Are you sure? Seriously!',ds+name+exten)=1 then begin
    astdeleter:=true;

    if list[n]^.item=255 then begin
      gsound;

      if ask(10,_CT[4],'CANCEL,Proceed','Choose carefully!','It''s a DIRECTORY: '+name+exten)<>1
        then begin
          astdeleter:=false;
          exit;
        end;

      findfirst(s+'\*.*',anyfile,d);
      while doserror=0 do begin
            if d.attr and directory=0 then FileDel(s+'\'+d.name);
            findnext(d)
      end;

      {$I-}
      rmdir(S);
      {$I+}
      if ioresult=5 then
        if opt.func=shell_ then begin
           gsound; gsound; { alarm 2 times }
        end else pr('Exist subdirectory!',1,_CT[4],true);
    end else filedel(s);
  end;
end;

procedure checkfn(src:string;var num:word;var str:string);
begin
  num:=str2num(getfollow(wholepara,src,false,false));

  if not (num in [1..tmpfilenum]) then begin
    gsound;
    pr('Wrong number!',1,_CT[7],true);
    halt;
  end;

  str:=path+list[num]^.name;
  if list[num]^.ext<>'' then str:=str+'.'+list[num]^.ext;
end;

procedure runsw(n:word;s:string);
begin
  if dbg_assistant=copy(S,1,12) then begin
     gsound;
     if opt.func<>shell_ then pr('Can''t run invoked file!',1,_CT[4],true);
     halt;
  end;

  { For user declarative extension ; if ext. is lower case, WHATKIND
    function cannot detect that is a batch file.
    Because GETLINE func. is return a value without modification as upper
    or lower case.
   }
  if pos('.BAT',ucase(s))>0 then list[n]^.item:=3;

  case list[n]^.item of
    255:chdir(S);
1,2,254:Run(s);  { 254 means user declarated item }
      3:Run('CALL '+s); { case of batch file }
   8,15:Run('LHA x '+S);
      9:Run('ARJ x -v -y '+S);
     10:Run('PKUNZIP '+S);
     11:Run('TOMP x '+S);
     12:Run('ZOO x '+S);
     13:Run('UC x '+S);
     14:Run('RAR x '+S);

 5..7,24,25:astdeleter(n,s);
 16..18:styper(n);

     19:Run('TURBO '+S);
     20:Run('TC '+S);
     21:Run('BC '+S);
     22:Run('GWBASIC '+S);
     23:Run('Q '+S);
     26:Run('HWP '+S);
     else if opt.func=shell_ then exit
          else pr('Can''t proceed! '+s,1,_CT[3],true);
  end;
  halt;
end;

procedure runfile;
var n:word;
    s:string;
begin
  checkfn('/:',n,s);
  runsw(n,s);
end;

procedure deleter;
var n:word;
    s:string;
begin
  checkfn('/D',n,s);
  astdeleter(n,s);
  halt;
end;

procedure typer;
var n:word;
    s:string;
begin
  checkfn('/T',n,s);

  if list[n]^.item=255 then begin
    gsound;
    halt;
  end;

  asttyper(n,s);
end;

function decodever:string;
var t:byte;
    s:string;
begin
  s:='';
  { convert to original message }

  for t:=1 to 80 do
    s:=s+chr(version[t] xor ord('D') xor ord('B') xor ord('G'));

  decodever:=s;
end;

function checkonoff(s:string):boolean;
begin
  if pos('ON',getfollow(s,'=',false,true))>0 then checkonoff:=true
  else                                            checkonoff:=false;
end;

function getexten(s:string):string;
var i:string;
    t,c:byte;
begin
  i:='';
  c:=0;

  for t:=1 to length(s) do begin
    case s[t] of
      ' ':continue;
      '=':break;
    end;
    inc(c);
    i:=i+s[t];
    if c>2 then break;
  end;

  getexten:=i;
end;

function space(s:string):boolean;
var b:boolean;
    t:byte;
begin
  b:=true;
  for t:=1 to length(s) do
      if s[t]<>' ' then begin
         b:=false;
         break;
      end;

  space:=b;
end;

function checksubfunction(s:string):boolean;
var ts:string;
    t:byte;
    b:boolean;
begin
  if pos('<',s)>0 then begin
     b:=false;

     ts:=ucase(getfollow(s,'<',false,false));

     if ts='' then begin
        dec(user_ext_cnt);
        checksubfunction:=false;
        exit;
     end;

     if ts = 'TYPER' then user_ext_data[user_ext_cnt].num:=65535
     else if ts = 'DELETER' then user_ext_data[user_ext_cnt].num:=65534
     else begin
               for t:=1 to user_ext_cnt do
                   if user_ext_data[t].ext=ts then begin
                      b:=true;
                      break;
                   end;

               if b then user_ext_data[user_ext_cnt].num:=user_ext_data[t].num
               else      dec(user_ext_cnt);
     end;

     checksubfunction:=true;
  end else checksubfunction:=false;
end;

procedure analyze_initfile;
const
  pmsg_para              ='[PARAMETERS]';
  pmsg_appli             ='[APPLICATIONS]';
  pmsg_exten             ='[EXTENSIONS]';

  msg_cust              ='CUSTOM';
  msg_exec              ='EXECUTIVES';
  msg_view              ='VIEWER';
  msg_enter_return      ='EXCHANGETABENTER';

var
  f           :       text;
  s,     v    :       string;
  section     :       byte;
  linecounter :       word;

  { In case section of; 0:nothing,  1:parameters,  2:applications,  3:extensions }
begin
  s:=paramstr(0);

  assign(f,copy(s,1,length(s)-3)+'INI');

{  assign(f,'c:\tp\product\dbg\d.ini');}

  {$I-}
  reset(f);
  {$I+}
  if ioresult<>0 then exit;

  section        :=0;
  linecounter    :=0;

  while not eof(f) do begin
    readln(f,s);
    s:=ucase(s);
    inc(linecounter);

    if s[1]=';' then continue;  { bypass a line }
    if pos(';',s)>0 then s:=copy(s,1,pos(';',s)-1);

    if pos(pmsg_para,s)>0 then begin
       section:=1; continue;
    end else if pos(pmsg_appli,s)>0 then begin
                section:=2; continue;
    end else if pos(pmsg_exten,s)>0 then begin
                section:=3; continue;
    end;

    if section=0 then continue;

    case section of
      1:begin
             if checkstr(s,msg_cust,false) then opt.cust_:=checkonoff(s);
             if checkstr(s,msg_exec,false) then opt.exec_:=checkonoff(s);
             if checkstr(s,msg_enter_return,false) then exchange_tab_enter:=checkonoff(s);
      end;

      2:if checkstr(s,msg_view,false) then begin
           v:=getfollow(s,'=',false,true);
           viewer:=getpath(v,1,true);
           viewer_option:=getoption(v,1);
           viewer_dest:=getpath(v,2,true);
      end;

      3:if (not space(s)) and (user_ext_cnt<user_ext_max) then begin
           inc(user_ext_cnt);
           user_ext_data[user_ext_cnt].ext:=getexten(s);
           if not checksubfunction(s) then
              user_ext_data[user_ext_cnt].num:=linecounter;
      end;

    end;
  end;

  close(f);
end;
