{
                    DOT-BO-GI assistant: MINI SHELL
                    Being invoked by D.PAS only

                    (c) aromanix
}

var
  less:function(X, Y:list_pointer):boolean;

{$F+}
function lessname(X, Y:list_pointer):boolean;
begin LessName := X^.Name < Y^.Name; end;

function Lessext(X, Y:list_pointer): Boolean;
begin Lessext := X^.ext < Y^.ext; end;

function lesssize(X, Y:list_pointer): Boolean;
begin LessSize := X^.Size < Y^.Size; end;

function lessnum(X, Y:list_pointer): Boolean;
begin Lessnum := X^.num < Y^.num; end;

function Lessdate(X, Y:list_pointer): Boolean;
begin
  Lessdate:=X^.time < Y^.time;
end;
{$F-}

procedure QuickSort(L, R: Integer);
var
  I, J:integer;
  X, Y:list_pointer;
begin
  I := L;
  J := R;
  X :=list[(L + R) div 2];
  repeat
    while Less(list[I], X) do Inc(I);
    while Less(X, list[J]) do Dec(J);

    if I <= J then begin
       Y:=list[I];
       list[I]:=list[J];
       list[J]:=Y;
       Inc(I);
       Dec(J);
    end;

  until I > J;
  if L < J then QuickSort(L, J);
  if I < R then QuickSort(I, R);
end;

procedure Minishell;
const
  sline         =       4;
  tline         =      18;
var
  l             :       string;
  selsize       :       longint;
  key,it,sel    :       word;

  y,                                 { indicate bar Y coordinate }
  vln,sm,                            { viewing last line, sorting method }
  blen,idx      :       byte;        { literbar length, literbar index }
  sus           :       boolean;     { select & unselect }

procedure drawselectbar(y:byte;nf:boolean);
begin
  asm
    cld
    cmp     nf,true
    jne     @falbar
    mov     bl,113
    jmp     @contrubar
@falbar:
    mov     bl,7
@contrubar:
    mov     es,_DISPSEG
    mov     al,y
    dec     al
    mov     dl,160
    mul     dl
    mov     di,ax
    inc     di
    mov     cx,4
@cont:
    mov     es:[di],bl
    add     di,2
    loop    @cont
  end;
end;

procedure viewinfo(idx:word;y:byte);
var dt:datetime;
begin
    { print file number }
    str(list[idx]^.num:4,l);
    fprint(l,1,y,_CT[7]);

    l:='----';
    if list[idx]^.attr and readonly<>0 then l[1]:='r';
    if list[idx]^.attr and hidden<>0 then l[2]:='h';
    if list[idx]^.attr and sysfile<>0 then l[3]:='s';
    if list[idx]^.attr and archive<>0 then l[4]:='a';
    fprint(l,6,y,_CT[7]);

    l:='            '; { 12 blanks }
    move(list[idx]^.name[1],l[1],length(list[idx]^.name));
    move(list[idx]^.ext[1],l[10],length(list[idx]^.ext));

    { print file name & extension }
    fprint(l,11,y,list[idx]^.col);

    { print file size & converted size }
    if list[idx]^.item=255 then l:=dir_msg else str(list[idx]^.size:10,l);
    fprint(l+' ('+sizecf(list[idx]^.size)+')',24,y,_CT[7]);

    { file date time }
    unpacktime(list[idx]^.time,dt);
    fprint(datecf(dt.year,dt.month,dt.day)+' '+
           timecf(dt.hour,dt.min),45,y,_CT[7]);

    if list[idx]^.selected then drawselectbar(y,true)
    else                        drawselectbar(y,false);
end;

procedure drawbar(i:word;y:byte;b:boolean);
var c:byte;
begin
  if b then c:=list[i]^.col*16 else c:=7;

  { draw bar }
  asm
    cld
    mov     bl,c
    mov     es,_DISPSEG
    mov     al,y
    dec     al
    mov     dl,160
    mul     dl
    mov     di,ax
    inc     di
    add     di,8
    mov     cx,74
@cont:
    mov     es:[di],bl
    add     di,2
    loop    @cont
  end;

  if not b then viewinfo(it,y);
end;

procedure downkey;
var t:byte;
begin
  if it<tmpfilenum then begin
    inc(it);
    if y<21 then inc(y)
    else begin
      { scroll up lines from sline upto 20 }
     { asm
        push    ds
        mov     es,DISPSEG
        mov     ds,DISPSEG
        mov     si,sline*160
        mov     di,(sline-1)*160
        mov     cx,(20-sline+1)*80
        cld
        rep     movsw
        pop     ds
      end;}
      for t:=sline to 20 do
          move(ptr(_DISPSEG,t*160)^,ptr(_DISPSEG,(t-1)*160)^,124);
      viewinfo(it,y);
    end;
  end;
end;

procedure upkey;
var t:byte;
begin
  if it>1 then begin
    dec(it);
    if y>sline then dec(y)
    else begin
      { scroll down lines from 20 downto sline }
      {
      asm
        push    ds
        mov     es,DISPSEG
        mov     ds,DISPSEG
        mov     si,20*160-2
        mov     di,21*160-2
        mov     cx,(20-sline+1)*80
        std
        rep     movsw
        pop     ds
      end;}
      for t:=20 downto sline do
          move(ptr(_DISPSEG,(t-1)*160)^,ptr(_DISPSEG,t*160)^,124);
      viewinfo(it,y);
    end;
  end;
end;

procedure pgdn;
var t:byte;
begin
  for t:=1 to tline-1 do begin
      mem[0:$41A]:=mem[0:$41C];
      downkey;
  end;
end;

procedure pgup;
var t:byte;
begin
  for t:=1 to tline-1 do begin
      mem[0:$41A]:=mem[0:$41C];
      upkey;
  end;
end;

procedure select;
begin
  if list[it]^.item=255 then begin
    downkey;
    exit;
  end;

  list[it]^.selected:=not list[it]^.selected;
  if list[it]^.selected then begin
    drawselectbar(y,true);
    inc(sel);
    inc(selsize,list[it]^.size);
  end else begin
    drawselectbar(y,false);
    dec(sel);
    dec(selsize,list[it]^.size);
  end;
  downkey;
end;

procedure unselect;
var t:word;
begin
  if sus then begin
    sel:=0;
    selsize:=0;
    for t:=1 to tmpfilenum do list[t]^.selected:=false;
    for t:=sline to vln do drawselectbar(t,false);
  end else begin
    sel:=0;
    selsize:=0;
    for t:=1 to tmpfilenum do
      if list[t]^.item<>255 then begin
        list[t]^.selected:=true;
        inc(sel);
        inc(selsize,list[t]^.size);
      end;
    for t:=sline to vln do
      if list[it+t-y]^.item<>255 then drawselectbar(t,true);
  end;
  sus:=not sus;
end;

procedure viewmslist(idx:word);
var t:byte;
begin
  for t:=sline to vln do viewinfo(idx+t-sline,t);
end;

procedure GoHome;
begin
  it:=1;
  y:=sline;
  viewmslist(1);
end;

procedure GoEnd;
begin
  it:=tmpfilenum;
  y:=vln;
  viewmslist(it+sline-y);
end;

procedure qsort;
begin
  if sm<4 then inc(sm) else sm:=0;

  case sm of
    0:fprint('NONE',49,1,_CT[8]+112);
    1:fprint('NAME',49,1,_CT[8]+112);
    2:fprint('EXT ',49,1,_CT[8]+112);
    3:fprint('SIZE',49,1,_CT[8]+112);
    4:fprint('DATE',49,1,_CT[8]+112);
  end;

  case sm of
    0:less:=lessnum;
    1:less:=lessname;
    2:less:=lessext;
    3:less:=lesssize;
    4:less:=lessdate;
  end;

  QuickSort(1,tmpfilenum);
  viewmslist(it+sline-y);
end;

procedure condition;
var s:string;
begin
  fprint('Selected:',1,25,_CT[7]);
  s:=num2str(sel);
  fprint(s+spc(' ',4-length(s)),10,25,_CT[15]);

  fprint('Selec.Size:',15,25,_CT[7]);
  s:=num2str(selsize);
  fprint(s+spc(' ',10-length(s)),26,25,_CT[15]);
end;

procedure literbar;
var t:byte;
begin
  if (tmpfilenum>16) and (not r_tab) then idx:=(it+sline-y)*16 div tmpfilenum;

  for t:=1 to 16 do begin
    if (t>idx) and (t<=idx+blen) then fprint(#219,80,sline+t,_CT[15])
    else                              fprint(#219,80,sline+t,_CT[8]);
  end;
end;

procedure initshell;
var
  t:word;
  p:dirstr;
  n:namestr;
  e:extstr;
begin
  it            :=1;      { list index }
  sm            :=0;      { NONE Sorting method defaulted }
  sel           :=0;      { selecting number }
  selsize       :=0;      { selecting size }
  y             :=sline;  { bar Y position }
  sus           :=false;  { unselect state }
  c_scr         :=0;      { reset pause counter }
  l_scr         :=2;      { reset scroll checker }

  cls;

  if tmpfilenum<(22-sline) then vln:=tmpfilenum+(sline-1) else vln:=21;

  for t:=1 to tmpfilenum do begin
      list[t]^.num:=t;
      list[t]^.selected:=false;
  end;

  getdiskinfos;
  volpath;

  fsplit(viewer,P,N,E);
  n:=n+spc(' ',8-length(n));
  fprint('INS.:View('+n,1,1,_CT[8]+112);
  fprint(')DEL.:DeleteSPC.:SelectF11:NONE SortF12:UnSel.  ',19,1,_CT[8]+112);

  if tmpfilenum=0 then begin
     opt.func:=0;
     puttime(72,1,_CT[1]+112);
     extrainfoview;
     halt;
  end;

  if tmpfilenum<16 then begin
     blen:=16;
     idx:=0;
  end else begin
      blen:=288 div tmpfilenum;
      if (tmpfilenum-(tline-1))*16 div tmpfilenum+blen<16 then inc(blen);
      if blen<1 then blen:=1;
  end;

  if r_tab then begin
    it     :=r_code.it;
    y      :=r_code.y;
    idx    :=r_code.idx;
    r_tab  :=false;
  end;

  literbar;
  viewmslist(it+sline-y);   { it+sline-y = index of list }

  c_scr:=0; { reset pause counter }
  l_scr:=22; { reset scroll checker }
  extrainfoview;
  condition;

  { literbar }
  fprint(#24,80,sline,112);
  fprint(#25,80,sline+tline-1,112);
end;

function getline(line:word):string;
var f:text;
    s,p:string;
    t:word;
begin
  p:=paramstr(0);

  assign(f,copy(p,1,length(p)-3)+'INI');

{  assign(f,'c:\tp\product\dbg\d.ini');}

  {$I-}
  reset(f);
  {$I+}
  if ioresult<>0 then exit;

  t:=0;
  while not eof(f) do begin
        readln(f,s);
        inc(t);
        if t=line then break;
  end;

  if pos(';',s)>0 then s:=copy(s,1,pos(';',s)-1);
  getline:=s;

  close(f);
end;

procedure changeform(var s:string;f:string);
var l:byte;
begin
  if pos('!',s)=0 then exit;

  while pos('!',s)>0 do
    if pos('!.!',s)>0 then begin
       l:=pos('!.!',s);
       delete(s,l,3);
       insert(path+f,s,l);
    end else if pos('!',s)>0 then begin
                l:=pos('!',s);
                delete(s,l,1);
                insert(path+list[it]^.name,s,l);
    end;
end;

procedure user_ext_process(f:string);
var t:byte;
    s:string;
    ff:boolean;
begin
  ff:=false;
  for t:=1 to user_ext_cnt do
      if user_ext_data[t].ext=list[it]^.ext then begin
         ff:=true;
         break;
      end;

  if not ff then exit;      { if not found }

  case user_ext_data[t].num of
    65535:asttyper(it,path+f);
    65534:begin
               astdeleter(it,path+f);
               halt;
    end;
  end;

  s:=getline(user_ext_data[t].num);
  s:=getfollow(s,'=',false,true);

  changeform(s,f);

  list[it]^.item:=254;   { 254 means user declarated item }
  runsw(it,s);
end;

procedure enter;
var s:string;
begin
  with list[it]^ do begin
       s:=name;
       if length(ext)>0 then s:=s+'.'+ext;

       case item of
            255:if name<>'.' then begin
                   chdir(path+s);
                   compl_path:=completepath(getpath(path+s,1,true));
                   filelist_gathering(compl_path);
                   initshell;
            end;
            else begin
                 if user_ext_cnt>0 then user_ext_process(s);
                 runsw(it,path+s);
            end;
       end;
  end;
end;

procedure tab_process;
begin
  { it:word; y,idx:byte }

  tab        :=true;

  r_code.it  :=it;
  r_code.y   :=y;
  r_code.idx :=idx;

  enter;

  tab        :=false;
end;

procedure sdeleter;
var s:string;
    c:word;
    lc:byte;
begin
  lc:=0;

  if sel=0 then begin
     s:=path+list[it]^.name;
     if list[it]^.ext<>'' then s:=s+'.'+list[it]^.ext;

     if astdeleter(it,s) then begin
        filelist_gathering(compl_path);
        initshell;
     end;
  end else begin
      for c:=1 to tmpfilenum do
          if list[c]^.selected then begin

             s:=path+list[c]^.name;
             if list[c]^.ext<>'' then s:=s+'.'+list[c]^.ext;

             fsplit(s,Path,Name,Exten);

             if lc<>3 then
                lc:=ask(10,_CT[4],'CANCEL,SKIP,DELETE,DELETE ALL',
                        'Choose one with care!',name+exten);

             case lc of
                  0,255:exit;
                  2,3:filedel(s);
             end;
      end;

      filelist_gathering(compl_path);
      initshell;
  end;
end;

begin
  initshell;

  drawbar(it,y,true);
  repeat
    puttime(72,1,_CT[1]+112);

    key:=getkey;
    if key=0 then continue;

    drawbar(it,y,false);
    case key of
      $0F09:if exchange_tab_enter then enter else tab_process;
      $2D00:halt; { alt + X }
      $1C0D,$E00D:if exchange_tab_enter then tab_process else enter;
      $4B00,$4800:upkey;
      $5000,$4D00:downkey;
      $3920:select;
      $4900:pgup;
      $5100:pgdn;
      $4700:gohome;
      $4F00:goend;
      $8600:unselect;
      $8500:qsort;
      $5300:sdeleter;
      $5200:styper(it);
    end;

    literbar;
    drawbar(it,y,true);
    condition;
  until (key=$011B) and (ask(10,_CT[9],'QUIT,CANCEL','','Tired already?')=0);

  drawbar(it,y,false);
  halt;    { Exit Shell }
end;
